`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/05/11 19:48:32
// Design Name: 
// Module Name: key_decoder
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

`define key_1 9'h016
`define key_2 9'h01e
`define key_3 9'h026
`define key_4 9'h025
`define key_5 9'h02e
`define key_6 9'h036
`define key_7 9'h03d
`define key_8 9'h03e
`define key_9 9'h046
`define key_0 9'h045
`define key_a 9'h01c
`define key_s 9'h01b
`define key_m 9'h03a
`define key_enter 9'h05a


module key_decoder(
    result, 
    select_in,
    clk,
    rst
    );
    output reg [3:0] result;
    input clk, rst;
    input [8:0] select_in;

    reg [3:0] result_tmp;
    
    always @*
        case (select_in)
            `key_0:
                result_tmp = 4'd0;
            `key_1:
                result_tmp = 4'd1;
            `key_2:
                result_tmp = 4'd2;
            `key_3:
                result_tmp = 4'd3;
            `key_4:
                result_tmp = 4'd4;
            `key_5:
                result_tmp = 4'd5;
            `key_6:
                result_tmp = 4'd6;
            `key_7:
                result_tmp = 4'd7;
            `key_8:
                result_tmp = 4'd8;
            `key_9:
                result_tmp = 4'd9;
            `key_a:
                result_tmp = 4'd10;
            `key_s:
                result_tmp = 4'd11;
            `key_m:
                result_tmp = 4'd12;
            `key_enter:
                result_tmp = 4'd13;
            default:
                result_tmp = result; 
        endcase

    always @(posedge clk or posedge rst)
        if (rst)
            result <= 4'd0;
        else
            result <= result_tmp;
    
endmodule




