`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/05/12 16:30:11
// Design Name: 
// Module Name: topmodule
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module topmodule(
    D_ssd,
    ssd_ctl,
    clk,
    rst,
    PS2_DATA,
    PS2_CLK
    );

    output [7:0] D_ssd;
    output [3:0] ssd_ctl;
    
    input clk;
    input rst;

    inout PS2_CLK;
    inout PS2_DATA;
    
    wire [511:0] key_down;
    wire [8:0] last_change;
    wire key_valid;
    wire [3:0] decode_result;

    assign ssd_ctl = 4'b1110; //select which 7-segs to display

    KeyboardDecoder U0(
	.key_down(key_down),
	.last_change(last_change),
	.key_valid(key_valid),
	.PS2_DATA(PS2_DATA),
	.PS2_CLK(PS2_CLK),
	.rst(rst),
	.clk(clk)
    );
    
    key_decoder U1(
    .result(decode_result), 
    .select_in(last_change),
    .clk(clk),
    .rst(rst)
    );

    display U3(.D_ssd(D_ssd), .i(decode_result));

endmodule
